Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -5111,36 +5191,33 @@
 !> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
 !------------------------------------------------------------------------------!
- SUBROUTINE sumnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa,            &
-                     pn_crit_ocnv, pk_sa, pk_ocnv )
+ SUBROUTINE sumnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
 
     IMPLICIT NONE
-    
-!-- Input and output variables
+
+    REAL(wp) ::  a_s1 = 6.1E-7_wp   !< (1/s)
+    REAL(wp) ::  a_s2 = 0.39E-7_wp  !< (1/s) (Paasonen et al. Table 3.)
+
     REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
     REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-    REAL(wp), INTENT(out) ::  pd_crit !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv !< Lever: if pk_ocnv = 1, organic 
-                                      !< compounds are involved in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa   !< Lever: if pk_sa = 1, H2SO4 is involved
-                                      !< in nucleation 
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucl. rate (#/(m3 s))
-!-- Local variables
-    REAL(wp) ::  As1 = 6.1E-7_wp  !< (1/s)
-    REAL(wp) ::  As2 = 0.39E-7_wp !< (1/s) (Paasonen et al. Table 3.)
-    
+
+    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
+!
 !-- Nucleation rate  (#/m3/s)
-    pnuc_rate = As1 * pc_sa + As2 * pc_org 
-!-- Both Organic compounds and H2SO4 are involved when SUMnucleation is assumed.
+    pnuc_rate = a_s1 * pc_sa + a_s2 * pc_org
+!
+!-- Both organic compounds and H2SO4 are involved when sumnucleation is assumed.
     pn_crit_sa   = 1.0_wp
-    pn_crit_ocnv = 1.0_wp 
+    pn_crit_ocnv = 1.0_wp
     pk_sa        = 1.0_wp
-    pk_ocnv      = 1.0_wp           
+    pk_ocnv      = 1.0_wp
     pd_crit      = 1.5E-9_wp   ! (m)
-    
+
  END SUBROUTINE sumnucl
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5150,68 +5227,61 @@
 !> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
 !------------------------------------------------------------------------------!
- SUBROUTINE hetnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa,            &
-                     pn_crit_ocnv, pk_sa, pk_ocnv )
+ SUBROUTINE hetnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
 
     IMPLICIT NONE
-    
-!-- Input and output variables
+
+    REAL(wp) ::  z_k_het = 4.1E-14_wp  !< (cm3/s) (Paasonen et al. Table 4: median)
+
     REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
     REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-    REAL(wp), INTENT(out) ::  pd_crit !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv !< Lever: if pk_ocnv = 1, organic 
-                                      !< compounds are involved in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa   !< Lever: if pk_sa = 1, H2SO4 is involved
-                                      !< in nucleation 
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucl. rate (#/(m3 s))
-!-- Local variables
-    REAL(wp) ::  zKhet = 4.1E-14_wp !< (cm3/s) (Paasonen et al. Table 4: median)
-    
+
+    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
+!
 !-- Nucleation rate (#/m3/s)
-    pnuc_rate = zKhet * pc_sa * pc_org * 1.0E6_wp 
-!-- Both Organic compounds and H2SO4 are involved when heteromolecular
+    pnuc_rate = z_k_het * pc_sa * pc_org * 1.0E6_wp
+!
+!-- Both organic compounds and H2SO4 are involved when heteromolecular
 !-- nucleation is assumed.
     pn_crit_sa   = 1.0_wp
-    pn_crit_ocnv = 1.0_wp 
+    pn_crit_ocnv = 1.0_wp
     pk_sa        = 1.0_wp
-    pk_ocnv      = 1.0_wp  
+    pk_ocnv      = 1.0_wp
     pd_crit      = 1.5E-9_wp   ! (m)
-    
+
  END SUBROUTINE hetnucl
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Takes into account the homomolecular nucleation of sulphuric acid H2SO4 with 
+!> Takes into account the homomolecular nucleation of sulphuric acid H2SO4 with
 !> both of the available vapours.
 !> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
 !------------------------------------------------------------------------------!
- SUBROUTINE SAnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa,             &
-                    pn_crit_ocnv, pk_sa, pk_ocnv )
+ SUBROUTINE SAnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
 
     IMPLICIT NONE
-    
-!-- Input and output variables
+
+    REAL(wp) ::  z_k_sa1 = 1.1E-14_wp  !< (cm3/s)
+    REAL(wp) ::  z_k_sa2 = 3.2E-14_wp  !< (cm3/s) (Paasonen et al. Table 3.)
+
     REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
     REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-    REAL(wp), INTENT(out) ::  pd_crit !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv !< Lever: if pk_ocnv = 1, organic 
-                                      !< compounds are involved in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa   !< Lever: if pk_sa = 1, H2SO4 is involved
-                                      !< in nucleation 
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucleation rate (#/(m3 s))
-!-- Local variables
-    REAL(wp) ::  zKsa1 = 1.1E-14_wp !< (cm3/s)
-    REAL(wp) ::  zKsa2 = 3.2E-14_wp  !< (cm3/s) (Paasonen et al. Table 3.)
-    
+
+    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucleation rate (#/(m3 s))
+!
 !-- Nucleation rate (#/m3/s)
-    pnuc_rate = ( zKsa1 * pc_sa ** 2.0_wp + zKsa2 * pc_sa * pc_org ) * 1.0E+6_wp 
-!-- Both Organic compounds and H2SO4 are involved when SAnucleation is assumed.
+    pnuc_rate = ( z_k_sa1 * pc_sa**2 + z_k_sa2 * pc_sa * pc_org ) * 1.0E+6_wp
+!
+!-- Both organic compounds and H2SO4 are involved when SAnucleation is assumed.
     pn_crit_sa   = 3.0_wp
     pn_crit_ocnv = 1.0_wp 
@@ -5219,6 +5289,7 @@
     pk_ocnv      = 1.0_wp
     pd_crit      = 1.5E-9_wp   ! (m)
-    
+
  END SUBROUTINE SAnucl
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5228,65 +5299,62 @@
 !> See Paasonen et al. (2010), Atmos. Chem. Phys., 10, 11223-11242.
 !------------------------------------------------------------------------------!
- SUBROUTINE SAORGnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa,          &
-                       pn_crit_ocnv, pk_sa, pk_ocnv )
+ SUBROUTINE SAORGnucl( pc_sa, pc_org, pnuc_rate, pd_crit, pn_crit_sa, pn_crit_ocnv, pk_sa, pk_ocnv )
 
     IMPLICIT NONE
-    
-!-- Input and output variables
+
+    REAL(wp) ::  z_k_s1 = 1.4E-14_wp    !< (cm3/s])
+    REAL(wp) ::  z_k_s2 = 2.6E-14_wp    !< (cm3/s])
+    REAL(wp) ::  z_k_s3 = 0.037E-14_wp  !< (cm3/s]) (Paasonen et al. Table 3.)
+
     REAL(wp), INTENT(in) ::  pc_org   !< organic vapour concentration (#/m3)
     REAL(wp), INTENT(in) ::  pc_sa    !< H2SO4 conc. (#/m3)
-    REAL(wp), INTENT(out) ::  pd_crit !< critical diameter of clusters (m)
-    REAL(wp), INTENT(out) ::  pk_ocnv !< Lever: if pk_ocnv = 1, organic 
-                                      !< compounds are involved in nucleation
-    REAL(wp), INTENT(out) ::  pk_sa   !< Lever: if pk_sa = 1, H2SO4 is involved 
-                                      !< in nucleation 
-    REAL(wp), INTENT(out) ::  pn_crit_ocnv !< number of organic molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pn_crit_sa   !< number of H2SO4 molecules in 
-                                           !< cluster (#)
-    REAL(wp), INTENT(out) ::  pnuc_rate    !< nucl. rate (#/(m3 s))
-!-- Local variables
-    REAL(wp) ::  zKs1 = 1.4E-14_wp   !< (cm3/s])
-    REAL(wp) ::  zKs2 = 2.6E-14_wp   !< (cm3/s])
-    REAL(wp) ::  zKs3 = 0.037E-14_wp !< (cm3/s]) (Paasonen et al. Table 3.)
-    
-!-- Nucleation rate (#/m3/s)         
-    pnuc_rate = ( zKs1 * pc_sa **2 + zKs2 * pc_sa * pc_org + zKs3 *            &
-                  pc_org ** 2.0_wp ) * 1.0E+6_wp
+
+    REAL(wp), INTENT(out) ::  pd_crit  !< critical diameter of clusters (m)
+    REAL(wp), INTENT(out) ::  pk_ocnv  !< if pk_ocnv = 1, organic compounds participate in nucleation
+    REAL(wp), INTENT(out) ::  pk_sa    !< if pk_sa = 1, H2SO4 participate in nucleation
+    REAL(wp), INTENT(out) ::  pn_crit_ocnv  !< number of organic molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pn_crit_sa    !< number of H2SO4 molecules in cluster (#)
+    REAL(wp), INTENT(out) ::  pnuc_rate     !< nucl. rate (#/(m3 s))
+!
+!-- Nucleation rate (#/m3/s)
+    pnuc_rate = ( z_k_s1 * pc_sa**2 + z_k_s2 * pc_sa * pc_org + z_k_s3 * pc_org**2 ) * 1.0E+6_wp
+!
 !-- Organic compounds not involved when kinetic nucleation is assumed.
     pn_crit_sa   = 3.0_wp
-    pn_crit_ocnv = 3.0_wp 
+    pn_crit_ocnv = 3.0_wp
     pk_sa        = 1.0_wp
     pk_ocnv      = 1.0_wp
     pd_crit      = 1.5E-9_wp   ! (m)
- 
+
  END SUBROUTINE SAORGnucl
- 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Function zNnuc_tayl is connected to the calculation of self-coagualtion of 
+!> Function z_n_nuc_tayl is connected to the calculation of self-coagualtion of 
 !> small particles. It calculates number of the particles in the size range
 !> [zdcrit,dx] using Taylor-expansion (please note that the expansion is not 
 !> valid for certain rational numbers, e.g. -4/3 and -3/2)
 !------------------------------------------------------------------------------!
- FUNCTION zNnuc_tayl( d1, dx, zm_para, zjnuc_t, zeta, zGRtot ) 
+ FUNCTION z_n_nuc_tayl( d1, dx, zm_para, zjnuc_t, zeta, z_gr_tot )
+
     IMPLICIT NONE
-  
-    INTEGER(iwp) ::  i
-    REAL(wp) ::  d1
-    REAL(wp) ::  dx
-    REAL(wp) ::  zjnuc_t
-    REAL(wp) ::  zeta
-    REAL(wp) ::  term1
-    REAL(wp) ::  term2
-    REAL(wp) ::  term3
-    REAL(wp) ::  term4
-    REAL(wp) ::  term5
-    REAL(wp) ::  zNnuc_tayl
-    REAL(wp) ::  zGRtot
-    REAL(wp) ::  zm_para
-
-    zNnuc_tayl = 0.0_wp
+
+    INTEGER(iwp) ::  i !< running index
+
+    REAL(wp) ::  d1            !< lower diameter limit
+    REAL(wp) ::  dx            !< upper diameter limit
+    REAL(wp) ::  zjnuc_t       !< initial nucleation rate (1/s)
+    REAL(wp) ::  zeta          !< ratio of CS/GR (m) (condensation sink / growth rate)
+    REAL(wp) ::  term1         !<
+    REAL(wp) ::  term2         !<
+    REAL(wp) ::  term3         !<
+    REAL(wp) ::  term4         !<
+    REAL(wp) ::  term5         !<
+    REAL(wp) ::  z_n_nuc_tayl  !< final nucleation rate (1/s)
+    REAL(wp) ::  z_gr_tot      !< total growth rate (nm/h)
+    REAL(wp) ::  zm_para       !< m parameter in Lehtinen et al. (2007), Eq. 6
+
+    z_n_nuc_tayl = 0.0_wp
 
     DO  i = 0, 29
@@ -5296,17 +5364,14 @@
           term1 = term1 * REAL( i, SELECTED_REAL_KIND(12,307) )
        END IF
-       term2 = ( REAL( i, SELECTED_REAL_KIND(12,307) ) * ( zm_para + 1.0_wp    &
-               ) + 1.0_wp ) * term1
-       term3 = zeta ** i
+       term2 = ( REAL( i, SELECTED_REAL_KIND(12,307) ) * ( zm_para + 1.0_wp ) + 1.0_wp ) * term1
+       term3 = zeta**i
        term4 = term3 / term2
-       term5 = REAL( i, SELECTED_REAL_KIND(12,307) ) * ( zm_para + 1.0_wp )    &
-               + 1.0_wp
-       zNnuc_tayl = zNnuc_tayl + term4 * ( dx ** term5 - d1 ** term5 ) 
+       term5 = REAL( i, SELECTED_REAL_KIND(12,307) ) * ( zm_para + 1.0_wp ) + 1.0_wp
+       z_n_nuc_tayl = z_n_nuc_tayl + term4 * ( dx**term5 - d1**term5 )
     ENDDO
-    zNnuc_tayl = zNnuc_tayl * zjnuc_t * EXP( -zeta *                           &
-                   ( d1 ** ( zm_para + 1 ) ) ) / zGRtot
-                  
- END FUNCTION zNnuc_tayl
- 
+    z_n_nuc_tayl = z_n_nuc_tayl * zjnuc_t * EXP( -zeta * ( d1**( zm_para + 1 ) ) ) / z_gr_tot
+
+ END FUNCTION z_n_nuc_tayl
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -5318,57 +5383,55 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE gpparth2o( paero, ptemp, ppres, pcs, pcw, ptstep )
-        
+
     IMPLICIT NONE
-!
-!-- Input and output variables  
-    REAL(wp), INTENT(in) ::  ppres  !< Air pressure (Pa)
-    REAL(wp), INTENT(in) ::  pcs    !< Water vapour saturation 
-                                             !< concentration (kg/m3)
-    REAL(wp), INTENT(in) ::  ptemp  !< Ambient temperature (K)  
-    REAL(wp), INTENT(in) ::  ptstep !< timestep (s)
-    REAL(wp), INTENT(inout) ::  pcw !< Water vapour concentration 
-                                                !< (kg/m3)
-    TYPE(t_section), INTENT(inout) ::  paero(nbins) !< Aerosol properties
-!-- Local variables
-    INTEGER(iwp) ::  b !< loop index
-    INTEGER(iwp) ::  nstr
-    REAL(wp) ::  adt     !< internal timestep in this subroutine
-    REAL(wp) ::  adtc(nbins) 
-    REAL(wp) ::  rhoair      
-    REAL(wp) ::  ttot       
-    REAL(wp) ::  zact    !< Water activity
-    REAL(wp) ::  zaelwc1 !< Current aerosol water content 
-    REAL(wp) ::  zaelwc2 !< New aerosol water content after 
-                                     !< equilibrium calculation     
-    REAL(wp) ::  zbeta   !< Transitional correction factor 
-    REAL(wp) ::  zcwc    !< Current water vapour mole concentration
-    REAL(wp) ::  zcwcae(nbins) !< Current water mole concentrations
-                               !< in aerosols
-    REAL(wp) ::  zcwint  !< Current and new water vapour mole concentrations
-    REAL(wp) ::  zcwintae(nbins) !< Current and new water mole concentrations
-                                 !< in aerosols
-    REAL(wp) ::  zcwn    !< New water vapour mole concentration
-    REAL(wp) ::  zcwnae(nbins) !< New water mole concentration in aerosols
-    REAL(wp) ::  zcwsurfae(nbins) !< Surface mole concentration
-    REAL(wp) ::  zcwtot  !< Total water mole concentration
-    REAL(wp) ::  zdfh2o
-    REAL(wp) ::  zhlp1
-    REAL(wp) ::  zhlp2
-    REAL(wp) ::  zhlp3       
-    REAL(wp) ::  zka(nbins)     !< Activity coefficient       
-    REAL(wp) ::  zkelvin(nbins) !< Kelvin effect
-    REAL(wp) ::  zknud
-    REAL(wp) ::  zmfph2o        !< mean free path of H2O gas molecule
-    REAL(wp) ::  zmtae(nbins)   !< Mass transfer coefficients
-    REAL(wp) ::  zrh            !< Relative humidity [0-1]      
-    REAL(wp) ::  zthcond       
-    REAL(wp) ::  zwsatae(nbins) !< Water saturation ratio above aerosols
+
+    INTEGER(iwp) ::  ib   !< loop index
+    INTEGER(iwp) ::  nstr !<
+
+    REAL(wp) ::  adt        !< internal timestep in this subroutine
+    REAL(wp) ::  rhoair     !< air density (kg/m3)
+    REAL(wp) ::  ttot       !< total time (s)
+    REAL(wp) ::  zact       !< Water activity
+    REAL(wp) ::  zaelwc1    !< Current aerosol water content (kg/m3)
+    REAL(wp) ::  zaelwc2    !< New aerosol water content after equilibrium calculation (kg/m3)
+    REAL(wp) ::  zbeta      !< Transitional correction factor
+    REAL(wp) ::  zcwc       !< Current water vapour mole concentration in aerosols (mol/m3)
+    REAL(wp) ::  zcwint     !< Current and new water vapour mole concentrations (mol/m3)
+    REAL(wp) ::  zcwn       !< New water vapour mole concentration (mol/m3)
+    REAL(wp) ::  zcwtot     !< Total water mole concentration (mol/m3)
+    REAL(wp) ::  zdfh2o     !< molecular diffusion coefficient (cm2/s) for water
+    REAL(wp) ::  zhlp1      !< intermediate variable to calculate the mass transfer coefficient
+    REAL(wp) ::  zhlp2      !< intermediate variable to calculate the mass transfer coefficient
+    REAL(wp) ::  zhlp3      !< intermediate variable to calculate the mass transfer coefficient
+    REAL(wp) ::  zknud      !< Knudsen number
+    REAL(wp) ::  zmfph2o    !< mean free path of H2O gas molecule
+    REAL(wp) ::  zrh        !< relative humidity [0-1]
+    REAL(wp) ::  zthcond    !< thermal conductivity of air (W/m/K)
+
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcwcae     !< Current water mole concentrations
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcwintae   !< Current and new aerosol water mole concentration
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcwnae     !< New water mole concentration in aerosols
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcwsurfae  !< Surface mole concentration
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zkelvin    !< Kelvin effect
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zmtae      !< Mass transfer coefficients
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zwsatae    !< Water saturation ratio above aerosols
+
+    REAL(wp), INTENT(in) ::  ppres   !< Air pressure (Pa)
+    REAL(wp), INTENT(in) ::  pcs     !< Water vapour saturation concentration (kg/m3)
+    REAL(wp), INTENT(in) ::  ptemp   !< Ambient temperature (K)
+    REAL(wp), INTENT(in) ::  ptstep  !< timestep (s)
+
+    REAL(wp), INTENT(inout) ::  pcw  !< Water vapour concentration (kg/m3)
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero  !< Aerosol properties
 !
 !-- Relative humidity [0-1]
     zrh = pcw / pcs
+!
 !-- Calculate the condensation only for 2a/2b aerosol bins
-    nstr = in2a
+    nstr = start_subrange_2a
+!
 !-- Save the current aerosol water content, 8 in paero is H2O
-    zaelwc1 = SUM( paero(in1a:fn2b)%volc(8) ) * arhoh2o
+    zaelwc1 = SUM( paero(start_subrange_1a:end_subrange_2b)%volc(8) ) * arhoh2o
 !
 !-- Equilibration:
@@ -5380,122 +5443,117 @@
        ENDIF
     ENDIF
-!                                        
+!
 !-- The new aerosol water content after equilibrium calculation
-    zaelwc2 = SUM( paero(in1a:fn2b)%volc(8) ) * arhoh2o
+    zaelwc2 = SUM( paero(start_subrange_1a:end_subrange_2b)%volc(8) ) * arhoh2o
+!
 !-- New water vapour mixing ratio (kg/m3)
     pcw = pcw - ( zaelwc2 - zaelwc1 ) * ppres * amdair / ( argas * ptemp )
-!                  
+!
 !-- Initialise variables
-    adtc(:)  = 0.0_wp
-    zcwc     = 0.0_wp
-    zcwcae   = 0.0_wp       
-    zcwint   = 0.0_wp
-    zcwintae = 0.0_wp       
-    zcwn     = 0.0_wp
-    zcwnae   = 0.0_wp
-    zhlp1    = 0.0_wp
-    zwsatae  = 0.0_wp    
-!          
+    zcwsurfae(:) = 0.0_wp
+    zhlp1        = 0.0_wp
+    zhlp2        = 0.0_wp
+    zhlp3        = 0.0_wp
+    zmtae(:)     = 0.0_wp
+    zwsatae(:)   = 0.0_wp
+!
 !-- Air:
 !-- Density (kg/m3)
     rhoair = amdair * ppres / ( argas * ptemp )
-!-- Thermal conductivity of air                       
+!
+!-- Thermal conductivity of air
     zthcond = 0.023807_wp + 7.1128E-5_wp * ( ptemp - 273.16_wp )
-!             
-!-- Water vapour: 
-!
+!
+!-- Water vapour:
 !-- Molecular diffusion coefficient (cm2/s) (eq.16.17)
-    zdfh2o = ( 5.0_wp / ( 16.0_wp * avo * rhoair * 1.0E-3_wp *                 &
-             ( 3.11E-8_wp ) ** 2.0_wp ) ) * SQRT( argas * 1.0E+7_wp * ptemp *  &
-             amdair * 1.0E+3_wp * ( amh2o + amdair ) * 1.0E+3_wp / ( 2.0_wp *  &
-             pi * amh2o * 1.0E+3_wp ) )
-    zdfh2o = zdfh2o * 1.0E-4   ! Unit change to m^2/s 
-!    
+    zdfh2o = ( 5.0_wp / ( 16.0_wp * avo * rhoair * 1.0E-3_wp * 3.11E-8_wp**2 ) ) * SQRT( argas *   &
+               1.0E+7_wp * ptemp * amdair * 1.0E+3_wp * ( amh2o + amdair ) * 1.0E+3_wp /           &
+               ( pi * amh2o * 2.0E+3_wp ) )
+    zdfh2o = zdfh2o * 1.0E-4   ! Unit change to m^2/s
+!
 !-- Mean free path (eq. 15.25 & 16.29)
-    zmfph2o = 3.0_wp * zdfh2o * SQRT( pi * amh2o / ( 8.0_wp * argas * ptemp ) ) 
-    zka = 1.0_wp   ! Assume activity coefficients as 1 for now.
-!    
-!-- Kelvin effect (eq. 16.33) 
-    zkelvin = 1.0_wp                   
-    zkelvin(1:nbins) = EXP( 4.0_wp * surfw0 * amh2o / ( argas * ptemp *        &
-                            arhoh2o * paero(1:nbins)%dwet) )
-!                           
-! --Aerosols:
-    zmtae(:)     = 0.0_wp   ! mass transfer coefficient
-    zcwsurfae(:) = 0.0_wp   ! surface mole concentrations
-    DO  b = 1, nbins
-       IF ( paero(b)%numc > nclim  .AND.  zrh > 0.98_wp )  THEN
-!       
+    zmfph2o = 3.0_wp * zdfh2o * SQRT( pi * amh2o / ( 8.0_wp * argas * ptemp ) )
+!
+!-- Kelvin effect (eq. 16.33)
+    zkelvin(:) = EXP( 4.0_wp * surfw0 * amh2o / ( argas * ptemp * arhoh2o * paero(:)%dwet) )
+
+    DO  ib = 1, nbins_aerosol
+       IF ( paero(ib)%numc > nclim  .AND.  zrh > 0.98_wp )  THEN
+!
 !--       Water activity
-          zact = acth2o( paero(b) )
-!          
+          zact = acth2o( paero(ib) )
+!
 !--       Saturation mole concentration over flat surface. Limit the super-
-!--       saturation to max 1.01 for the mass transfer. Experimental!          
-          zcwsurfae(b) = MAX( pcs, pcw / 1.01_wp ) * rhoair / amh2o
-!          
+!--       saturation to max 1.01 for the mass transfer. Experimental!
+          zcwsurfae(ib) = MAX( pcs, pcw / 1.01_wp ) * rhoair / amh2o
+!
 !--       Equilibrium saturation ratio
-          zwsatae(b) = zact * zkelvin(b)
-!          
+          zwsatae(ib) = zact * zkelvin(ib)
+!
 !--       Knudsen number (eq. 16.20)
-          zknud = 2.0_wp * zmfph2o / paero(b)%dwet
-!          
+          zknud = 2.0_wp * zmfph2o / paero(ib)%dwet
+!
 !--       Transitional correction factor (Fuks & Sutugin, 1971)
-          zbeta = ( zknud + 1.0_wp ) / ( 0.377_wp * zknud + 1.0_wp + 4.0_wp /  &
-                  ( 3.0_wp * massacc(b) ) * ( zknud + zknud ** 2.0_wp ) )
-!                  
+          zbeta = ( zknud + 1.0_wp ) / ( 0.377_wp * zknud + 1.0_wp + 4.0_wp /                      &
+                  ( 3.0_wp * massacc(ib) ) * ( zknud + zknud**2 ) )
+!
 !--       Mass transfer of H2O: Eq. 16.64 but here D^eff =  zdfh2o * zbeta
-          zhlp1 = paero(b)%numc * 2.0_wp * pi * paero(b)%dwet * zdfh2o *    &
-                  zbeta 
+          zhlp1 = paero(ib)%numc * 2.0_wp * pi * paero(ib)%dwet * zdfh2o * zbeta
+!
 !--       1st term on the left side of the denominator in eq. 16.55
-          zhlp2 = amh2o * zdfh2o * alv * zwsatae(b) * zcwsurfae(b) /         &
-                  ( zthcond * ptemp )
-!--       2nd term on the left side of the denominator in eq. 16.55                           
-          zhlp3 = ( (alv * amh2o ) / ( argas * ptemp ) ) - 1.0_wp
+          zhlp2 = amh2o * zdfh2o * alv * zwsatae(ib) * zcwsurfae(ib) / ( zthcond * ptemp )
+!
+!--       2nd term on the left side of the denominator in eq. 16.55
+          zhlp3 = ( ( alv * amh2o ) / ( argas * ptemp ) ) - 1.0_wp
+!
 !--       Full eq. 16.64: Mass transfer coefficient (1/s)
-          zmtae(b) = zhlp1 / ( zhlp2 * zhlp3 + 1.0_wp )
+          zmtae(ib) = zhlp1 / ( zhlp2 * zhlp3 + 1.0_wp )
        ENDIF
     ENDDO
 !
 !-- Current mole concentrations of water
-    zcwc = pcw * rhoair / amh2o   ! as vapour
-    zcwcae(1:nbins) = paero(1:nbins)%volc(8) * arhoh2o / amh2o   ! in aerosols
-    zcwtot = zcwc + SUM( zcwcae )   ! total water concentration
-    ttot = 0.0_wp
-    adtc = 0.0_wp
-    zcwintae = zcwcae   
-!             
+    zcwc        = pcw * rhoair / amh2o   ! as vapour
+    zcwcae(:)   = paero(:)%volc(8) * arhoh2o / amh2o   ! in aerosols
+    zcwtot      = zcwc + SUM( zcwcae )   ! total water concentration
+    zcwnae(:)   = 0.0_wp
+    zcwintae(:) = zcwcae(:)
+!
 !-- Substepping loop
     zcwint = 0.0_wp
+    ttot   = 0.0_wp
     DO  WHILE ( ttot < ptstep )
        adt = 2.0E-2_wp   ! internal timestep
-!       
+!
 !--    New vapour concentration: (eq. 16.71)
-       zhlp1 = zcwc + adt * ( SUM( zmtae(nstr:nbins) * zwsatae(nstr:nbins) *   &
-                                   zcwsurfae(nstr:nbins) ) )   ! numerator
-       zhlp2 = 1.0_wp + adt * ( SUM( zmtae(nstr:nbins) ) )   ! denomin.
+       zhlp1 = zcwc + adt * ( SUM( zmtae(nstr:nbins_aerosol) * zwsatae(nstr:nbins_aerosol) *       &
+                                   zcwsurfae(nstr:nbins_aerosol) ) )   ! numerator
+       zhlp2 = 1.0_wp + adt * ( SUM( zmtae(nstr:nbins_aerosol) ) )   ! denomin.
        zcwint = zhlp1 / zhlp2   ! new vapour concentration
        zcwint = MIN( zcwint, zcwtot )
        IF ( ANY( paero(:)%numc > nclim )  .AND. zrh > 0.98_wp )  THEN
-          DO  b = nstr, nbins
-             zcwintae(b) = zcwcae(b) + MIN( MAX( adt * zmtae(b) *           &
-                          ( zcwint - zwsatae(b) * zcwsurfae(b) ),            &
-                          -0.02_wp * zcwcae(b) ), 0.05_wp * zcwcae(b) )
-             zwsatae(b) = acth2o( paero(b), zcwintae(b) ) * zkelvin(b)
+          DO  ib = nstr, nbins_aerosol
+             zcwintae(ib) = zcwcae(ib) + MIN( MAX( adt * zmtae(ib) * ( zcwint - zwsatae(ib) *      &
+                                                   zcwsurfae(ib) ), -0.02_wp * zcwcae(ib) ),       &
+                                            0.05_wp * zcwcae(ib) )
+             zwsatae(ib) = acth2o( paero(ib), zcwintae(ib) ) * zkelvin(ib)
           ENDDO
        ENDIF
-       zcwintae(nstr:nbins) = MAX( zcwintae(nstr:nbins), 0.0_wp )
-!       
+       zcwintae(nstr:nbins_aerosol) = MAX( zcwintae(nstr:nbins_aerosol), 0.0_wp )
+!
 !--    Update vapour concentration for consistency
-       zcwint = zcwtot - SUM( zcwintae(1:nbins) )
+       zcwint = zcwtot - SUM( zcwintae(1:nbins_aerosol) )
+!
 !--    Update "old" values for next cycle
        zcwcae = zcwintae
 
        ttot = ttot + adt
-    ENDDO   ! ADT 
-    zcwn   = zcwint
-    zcwnae = zcwintae
-    pcw    = zcwn * amh2o / rhoair
-    paero(1:nbins)%volc(8) = MAX( 0.0_wp, zcwnae(1:nbins) * amh2o / arhoh2o )
-    
+
+    ENDDO   ! ADT
+
+    zcwn      = zcwint
+    zcwnae(:) = zcwintae(:)
+    pcw       = zcwn * amh2o / rhoair
+    paero(:)%volc(8) = MAX( 0.0_wp, zcwnae(:) * amh2o / arhoh2o )
+
  END SUBROUTINE gpparth2o
 
@@ -5504,21 +5562,20 @@
 ! ------------
 !> Calculates the activity coefficient of liquid water 
-!------------------------------------------------------------------------------!    
+!------------------------------------------------------------------------------!
  REAL(wp) FUNCTION acth2o( ppart, pcw )
-               
+
     IMPLICIT NONE
 
-    TYPE(t_section), INTENT(in) ::  ppart !< Aerosol properties of a bin 
-    REAL(wp), INTENT(in), OPTIONAL ::  pcw !< molar concentration of water 
-                                           !< (mol/m3)
-
-    REAL(wp) ::  zns !< molar concentration of solutes (mol/m3)
-    REAL(wp) ::  znw !< molar concentration of water (mol/m3)
-
-    zns = ( 3.0_wp * ( ppart%volc(1) * arhoh2so4 / amh2so4 ) +               &
-                     ( ppart%volc(2) * arhooc / amoc ) +                     &
-            2.0_wp * ( ppart%volc(5) * arhoss / amss ) +                     &
-                     ( ppart%volc(6) * arhohno3 / amhno3 ) +                 &
-                     ( ppart%volc(7) * arhonh3 / amnh3 ) )
+    REAL(wp) ::  zns  !< molar concentration of solutes (mol/m3)
+    REAL(wp) ::  znw  !< molar concentration of water (mol/m3)
+
+    REAL(wp), INTENT(in), OPTIONAL ::  pcw !< molar concentration of water (mol/m3)
+
+    TYPE(t_section), INTENT(in) ::  ppart !< Aerosol properties of a bin
+
+    zns = ( 3.0_wp * ( ppart%volc(1) * arhoh2so4 / amh2so4 ) + ( ppart%volc(2) * arhooc / amoc ) + &
+            2.0_wp * ( ppart%volc(5) * arhoss / amss ) + ( ppart%volc(6) * arhohno3 / amhno3 ) +   &
+            ( ppart%volc(7) * arhonh3 / amnh3 ) )
+
     IF ( PRESENT(pcw) ) THEN
        znw = pcw
@@ -5526,9 +5583,10 @@
        znw = ppart%volc(8) * arhoh2o / amh2o
     ENDIF
-!-- Activity = partial pressure of water vapour / 
-!--            sat. vapour pressure of water over a bulk liquid surface
+!
+!-- Activity = partial pressure of water vapour / sat. vapour pressure of water over a liquid surface
 !--          = molality * activity coefficient (Jacobson, 2005: eq. 17.20-21)
-!-- Assume activity coefficient of 1 for water 
+!-- Assume activity coefficient of 1 for water
     acth2o = MAX( 0.1_wp, znw / MAX( EPSILON( 1.0_wp ),( znw + zns ) ) )
+
  END FUNCTION acth2o
 
